unit Unit4;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs,Data.DB, Vcl.Grids, Vcl.DBGrids,
  Vcl.StdCtrls, Aurelius.Bind.BaseDataset, Aurelius.Bind.Dataset, Aurelius.Mapping.Attributes,
  System.Generics.Collections;

type
  [Entity, Automapping]
  TCustomer = class
  private
    FId: Integer;
    FName: string;
    FCountry: string;
  public
    property Id: Integer read FId write FId;
    property Name: string read FName write FName;
    property Country: string read FCountry write FCountry;
  end;

  TForm4 = class(TForm)
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Button1: TButton;
    AureliusDataset1: TAureliusDataset;
    AureliusDataset1Id: TIntegerField;
    AureliusDataset1Name: TStringField;
    AureliusDataset1Country: TStringField;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form4: TForm4;

implementation

{$R *.dfm}

procedure TForm4.Button1Click(Sender: TObject);
begin
  var ds := Datasource1.Dataset;
  ds.Fields[0].Index := (ds.Fields.Count - 1);
  ds.Insert;
  ds.FieldByName('Id').AsInteger := 3;
  ds.FieldByName('Name').AsString := 'Wilhem';
  ds.FieldByName('Country').AsString := 'Germany';

  var myFieldVal := ds.FieldByName('Name').AsString;	// myFieldVal should end up 'A' but instead is '' (empty string)
  ds.Post;	// AV occurs here
end;

procedure TForm4.Button2Click(Sender: TObject);
begin
  Datasource1.DataSet := AureliusDataset1;
end;

procedure TForm4.FormCreate(Sender: TObject);
begin
  var List := TObjectList<TCustomer>.Create;
  var C := TCustomer.Create;
  C.Id := 11;
  C.Name := 'Ronaldo';
  C.Country := 'Brazil';
  List.Add(C);

  C := TCustomer.Create;
  C.Id := 12;
  C.Name := 'John';
  C.Country := 'USA';
  List.Add(C);

  AureliusDataset1.SetSourceList(List, True);
  AureliusDataset1.Open;
end;

end.
